// Auto-generated. Do not edit!

// (in-package clearpath_dock_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let DockInfo = require('./DockInfo.js');

//-----------------------------------------------------------

class DockProperties {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.docks = null;
    }
    else {
      if (initObj.hasOwnProperty('docks')) {
        this.docks = initObj.docks
      }
      else {
        this.docks = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DockProperties
    // Serialize message field [docks]
    // Serialize the length for message field [docks]
    bufferOffset = _serializer.uint32(obj.docks.length, buffer, bufferOffset);
    obj.docks.forEach((val) => {
      bufferOffset = DockInfo.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DockProperties
    let len;
    let data = new DockProperties(null);
    // Deserialize message field [docks]
    // Deserialize array length for message field [docks]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.docks = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.docks[i] = DockInfo.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.docks.forEach((val) => {
      length += DockInfo.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_dock_msgs/DockProperties';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'aa88a2d7ca6c8e5adf72c90d078c6ca9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message definition containing the properties for each of the docks available.
    
    clearpath_dock_msgs/DockInfo[] docks
    
    ================================================================================
    MSG: clearpath_dock_msgs/DockInfo
    # Message definition containing the information of a single dock. This includes identifiers, lat/lon and orientation of the dock.
    
    string name
    string uuid
    string frame
    string target_template
    
    # ISO 8601 date/time format of last successfull dock location setting
    string last_location_set_time
    
    # maximum allowable distance to allow for predocking. (ie. the distance within which the dock waypoint must be located)
    float32 max_predock_distance
    # the distance from the dock that the robot will navigate to prior to start docking
    float32 predock_distance
    
    # location of the dock
    float64 latitude
    float64 longitude
    float64 heading
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DockProperties(null);
    if (msg.docks !== undefined) {
      resolved.docks = new Array(msg.docks.length);
      for (let i = 0; i < resolved.docks.length; ++i) {
        resolved.docks[i] = DockInfo.Resolve(msg.docks[i]);
      }
    }
    else {
      resolved.docks = []
    }

    return resolved;
    }
};

module.exports = DockProperties;
